unit fTypeDef;

interface

uses
  Windows,
  Classes,
  Dialogs,
  SysUtils,
  Graphics;

type
  TMethod1 = function: string of object;
  TMethod2 = function(S: string): string of object;
  TMethod3 = function(const FileName: string; var Bitmap: TBitmap): Boolean of object;
  TMethod4 = procedure(c: TCanvas; r: TRect; b: TBitmap) of object;

  TMyBaseComponent = class(TComponent)
  public
    function Method1: string; virtual; abstract;
    function Method2(S: string): string; virtual; abstract;
    function Method3(const FileName: string; var Bitmap: TBitmap): Boolean; virtual; abstract;
    procedure Method4(c: TCanvas; r: TRect; b: TBitmap); virtual; abstract;
  end;

  TMyBaseComponentClass = class of TMyBaseComponent;

{ Public Function }
  function FindMethod(Obj: TObject; MethodName: string; var TheMethod: TMethod): Boolean;
  function GetBitmap(const FileName: string; var Bitmap: TBitmap): Boolean;
  function MyGetClass(LibName, ClsName: string; var h: HMODULE; var AClass: TPersistentClass): Boolean;
  procedure DrawBitmep(c: TCanvas; r: TRect; b: TBitmap);

implementation

function FindMethod(Obj: TObject; MethodName: string; var TheMethod: TMethod): Boolean;
begin
  Result := False;
  TheMethod.Code := Obj.MethodAddress(MethodName);
  if Assigned(TheMethod.Code) then
  begin
    Result := True;
    TheMethod.Data := Pointer(Obj);
  end;
end;

function GetBitmap(const FileName: string; var Bitmap: TBitmap): Boolean;
begin
  Bitmap := nil;
  if FileExists(FileName) then
  begin
    Bitmap := TBitmap.Create;
    Bitmap.LoadFromFile(FileName);
  end;
  Result := Bitmap <> nil;
end;

function MyGetClass(LibName, ClsName: string; var h: HMODULE; var AClass: TPersistentClass): Boolean;
begin
  h := 0;
  AClass := nil;
  if not FileExists(LibName)
  then ShowMessage('Library not found: ' + LibName)
  else begin
    h := LoadPackage(LibName);
    if h = 0
    then ShowMessage('LoadPackage Failure: ' + LibName)
    else AClass := GetClass(ClsName);
  end;
  Result := AClass <> nil;

  if not Result and (h<>0) then
  begin
    UnloadPackage(h);
  end;

end;

procedure DrawBitmep(c: TCanvas; r: TRect; b: TBitmap);
begin
  if b <> nil then
  begin
    c.Lock;
    try
      c.StretchDraw(r,b);
    finally
      c.Unlock;
    end;
  end;
end;

end.
